package cn.ibizlab.humanresource.core.humanresource.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.humanresource.core.humanresource.domain.HRContract;
import cn.ibizlab.humanresource.core.humanresource.filter.HRContractSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface HRContractMapper extends BaseMapper<HRContract>{

    Page<HRContract> searchActive(IPage page, @Param("srf") HRContractSearchContext context, @Param("ew") Wrapper<HRContract> wrapper) ;
    Page<HRContract> searchDefault(IPage page, @Param("srf") HRContractSearchContext context, @Param("ew") Wrapper<HRContract> wrapper) ;
    Page<HRContract> searchWaitSign(IPage page, @Param("srf") HRContractSearchContext context, @Param("ew") Wrapper<HRContract> wrapper) ;
    Page<HRContract> searchWaitStop(IPage page, @Param("srf") HRContractSearchContext context, @Param("ew") Wrapper<HRContract> wrapper) ;
    @Override
    HRContract selectById(Serializable id);
    @Override
    int insert(HRContract entity);
    @Override
    int updateById(@Param(Constants.ENTITY) HRContract entity);
    @Override
    int update(@Param(Constants.ENTITY) HRContract entity, @Param("ew") Wrapper<HRContract> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<HRContract> selectByHremployeeid(@Param("employeeid") Serializable employeeid) ;

    List<HRContract> selectByMgrorganizationid(@Param("organizationid") Serializable organizationid) ;

    List<HRContract> selectBySignorganizationid(@Param("organizationid") Serializable organizationid) ;

}
